searchData={"items":[{"type":"module","title":"CozyLogger","doc":"Logger helpers, providing format functions of various formats and seamless integrations with other libraries.","ref":"CozyLogger.html"},{"type":"module","title":"Features - CozyLogger","doc":"- Formats\n  - JSON\n- Integrations\n  - Phoenix\n  - Oban","ref":"CozyLogger.html#module-features"},{"type":"module","title":"Installation - CozyLogger","doc":"Add `:package_name` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:cozy_logger,  }\n  ]\nend\n```","ref":"CozyLogger.html#module-installation"},{"type":"module","title":"Usage - CozyLogger","doc":"For more information, see the [documentation](https://hexdocs.pm/cozy_logger).","ref":"CozyLogger.html#module-usage"},{"type":"module","title":"About the design - CozyLogger","doc":"- The **formats** are only responsible for formatting, and they do not handle any vendor-specific formats.\n- The **integrations** process telemetry events to print logs, and provide `install/0` or `install/1` functions for convenient initialization.","ref":"CozyLogger.html#module-about-the-design"},{"type":"module","title":"License - CozyLogger","doc":"Apache License 2.0","ref":"CozyLogger.html#module-license"},{"type":"module","title":"CozyLogger.Formats","doc":"Provides format functions for logger.","ref":"CozyLogger.Formats.html"},{"type":"module","title":"Usage - CozyLogger.Formats","doc":"# configure the default formatter\n    config :logger, :default_formatter,\n      format: {CozyLogger.Formats, :json},\n      truncate: :infinity,\n      utc_log: true,\n      metadata: :all,\n      colors: [enabled: false]","ref":"CozyLogger.Formats.html#module-usage"},{"type":"function","title":"CozyLogger.Formats.json/4","doc":"","ref":"CozyLogger.Formats.html#json/4"},{"type":"module","title":"CozyLogger.Formats.JSON","doc":"Provides utilities to format logs as JSON.","ref":"CozyLogger.Formats.JSON.html"},{"type":"function","title":"CozyLogger.Formats.JSON.format/4","doc":"","ref":"CozyLogger.Formats.JSON.html#format/4"},{"type":"module","title":"CozyLogger.Integrations.Oban","doc":"`CozyLogger` integration for `Oban`.","ref":"CozyLogger.Integrations.Oban.html"},{"type":"module","title":"Usage - CozyLogger.Integrations.Oban","doc":"You need to attach events handlers before starting the application:\n\n    defmodule Demo\n      use Application\n\n      def start(_type, _args) do\n        :ok = CozyLogger.Integrations.Oban.install()\n\n        children = [\n          # ...\n        ]\n\n        Supervisor.start_link(children, strategy: :one_for_one, name: Demo.Supervisor)\n      end\n    end","ref":"CozyLogger.Integrations.Oban.html#module-usage"},{"type":"module","title":"TODO - CozyLogger.Integrations.Oban","doc":"Currently, only the handler for `[:oban, :job, :exception]` is implemented.\n\nIf you need handlers for other events, feel free to contribute.","ref":"CozyLogger.Integrations.Oban.html#module-todo"},{"type":"function","title":"CozyLogger.Integrations.Oban.install/1","doc":"","ref":"CozyLogger.Integrations.Oban.html#install/1"},{"type":"function","title":"CozyLogger.Integrations.Oban.uninstall/0","doc":"","ref":"CozyLogger.Integrations.Oban.html#uninstall/0"},{"type":"module","title":"CozyLogger.Integrations.Phoenix","doc":"`CozyLogger` integration for `Phoenix`.\n\nPhoenix uses the `:telemetry` library for instrumentation. The following events\nare published by Phoenix:\n\n  * `[:phoenix, :endpoint, :start]`\n  * `[:phoenix, :endpoint, :stop]`\n  * `[:phoenix, :router_dispatch, :start]`\n  * `[:phoenix, :error_rendered]`\n  * `[:phoenix, :socket_connected]`\n  * `[:phoenix, :channel_joined]`\n  * `[:phoenix, :channel_handled_in]`\n  * ...\n\n`Phoenix.Logger`(the default logger) handles these events, and print logs accordingly.","ref":"CozyLogger.Integrations.Phoenix.html"},{"type":"module","title":"Usage - CozyLogger.Integrations.Phoenix","doc":"Before using this custom logger, you need to disable the default logger:\n\n    config :phoenix, :logger, false\n\nThen, you need to attach events handlers before starting the application:\n\n    defmodule Demo\n      use Application\n\n      def start(_type, _args) do\n        unless Application.fetch_env!(:phoenix, :logger) do\n          :ok = CozyLogger.Integrations.Phoenix.install()\n        end\n\n        children = [\n          # ...\n        ]\n\n        Supervisor.start_link(children, strategy: :one_for_one, name: Demo.Supervisor)\n      end\n    end","ref":"CozyLogger.Integrations.Phoenix.html#module-usage"},{"type":"module","title":"Parameter filtering - CozyLogger.Integrations.Phoenix","doc":"When logging parameters, CozyLogger.Integrations.Phoenix can filter out sensitive parameters\nsuch as passwords and tokens. Parameters to be filtered can be added via the\n`:filter_params` option:\n\n    CozyLogger.Integrations.Phoenix.install(filter_params: [\"password\", \"secret\"])\n\nWith the configuration above, CozyLogger.Integrations.Phoenix will filter any parameter that\ncontains the terms `password` or `secret`. The match is case sensitive.\n\nThe default value of `:filter_params` option is `[\"password\"]`.\n\nCozyLogger.Integrations.Phoenix can also filter all parameters by default and selectively keep\nparameters. This can be configured like so:\n\n    CozyLogger.Integrations.Phoenix.install(filter_params: {:keep, [\"id\", \"order\"]})\n\nWith the configuration above, CozyLogger.Integrations.Phoenix will filter all parameters,\nexcept those that match exactly `id` or `order`. If a kept parameter matches,\nall parameters nested under that one will also be kept.","ref":"CozyLogger.Integrations.Phoenix.html#module-parameter-filtering"},{"type":"module","title":"Dynamic log level - CozyLogger.Integrations.Phoenix","doc":"In some cases you may wish to set the log level dynamically on a per-request basis.\n\nTo do so, set the `:log` option to a tuple, `{Mod, Fun, Args}`. The `Plug.Conn.t()` for the\nrequest will be prepended to the provided list of arguments.\n\nWhen invoked, your function must return a [`Logger.level()`](`t:Logger.level()/0`) or `false`\nto disable logging for the request.\n\nFor example, in your Endpoint you might do something like this:\n\n      # lib/demo_web/endpoint.ex\n      plug Plug.Telemetry,\n        event_prefix: [:phoenix, :endpoint],\n        log: {__MODULE__, :log_level, []}\n\n      # Disables logging for routes like /status/*\n      def log_level(%{path_info: [\"status\" | _]}), do: false\n      def log_level(_), do: :info","ref":"CozyLogger.Integrations.Phoenix.html#module-dynamic-log-level"},{"type":"module","title":"TODO - CozyLogger.Integrations.Phoenix","doc":"Currently, only the handler for `[:phoenix, :endpoint, :stop]` is implemented.\n\nIf you need handlers for other events, feel free to contribute.","ref":"CozyLogger.Integrations.Phoenix.html#module-todo"},{"type":"function","title":"CozyLogger.Integrations.Phoenix.install/1","doc":"","ref":"CozyLogger.Integrations.Phoenix.html#install/1"},{"type":"function","title":"CozyLogger.Integrations.Phoenix.uninstall/0","doc":"","ref":"CozyLogger.Integrations.Phoenix.html#uninstall/0"},{"type":"extras","title":"CozyLogger","doc":"# CozyLogger\n\n[![CI](https://github.com/cozy-elixir/cozy_logger/actions/workflows/ci.yml/badge.svg)](https://github.com/cozy-elixir/cozy_logger/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/cozy_logger.svg)](https://hex.pm/packages/cozy_logger)\n\n<!-- MDOC -->\n\nLogger helpers, providing format functions of various formats and seamless integrations with other libraries.","ref":"readme.html"},{"type":"extras","title":"Features - CozyLogger","doc":"- Formats\n  - JSON\n- Integrations\n  - Phoenix\n  - Oban","ref":"readme.html#features"},{"type":"extras","title":"Installation - CozyLogger","doc":"Add `:package_name` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:cozy_logger,  }\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - CozyLogger","doc":"For more information, see the [documentation](https://hexdocs.pm/cozy_logger).","ref":"readme.html#usage"},{"type":"extras","title":"About the design - CozyLogger","doc":"- The **formats** are only responsible for formatting, and they do not handle any vendor-specific formats.\n- The **integrations** process telemetry events to print logs, and provide `install/0` or `install/1` functions for convenient initialization.","ref":"readme.html#about-the-design"},{"type":"extras","title":"License - CozyLogger","doc":"Apache License 2.0","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}